const path = require('path');
const express = require('express');
const morgan = require('morgan');
const app = express();
const cors =require('cors');
const { PORT} = require('../config');
//connect to db
//  

//app.use(cors());

app.use((req,res,next)=>{
 res.setHeader("Access-Control-Allow-Origin","*");
 next();
});



app.use(express.json());    
//import routes

const indexRoutes = require('./routes/index');

const { Mongoose } = require('mongoose');
//settings 
app.set('port',PORT);
app.set('views', path.join(__dirname,  'views'));
app.set('view engine','ejs');
app.engine('ejs', require('ejs').renderFile)

//middlewares
app.use(morgan('dev'));
app.use(require("body-parser").json());
app.use(express.urlencoded({extended: true}));
app.use(express.static(path.join(__dirname, 'public')));
//routes
app.use('/',indexRoutes);



//starting server

app.listen (app.get('port'), ()=>{
    console.log(`Server on port ${app.get('port')}`);
});


