const {Sequelize, DataTypes, Transaction } = require('sequelize');
const { DB_DATABASE, DB_USER, DB_PASSWORD, DB_HOST} =  require('../../config');

const sequelize = new Sequelize(
    DB_DATABASE,
    DB_USER, 
    DB_PASSWORD,
    {
      host: DB_HOST,
      dialect: 'mysql',
      operatorAliases: false,
      pool:{
        max:5,
        min:0,
        acquire: 30000,
        idle:10000,
      },
      logging: false,
     
});


sequelize.authenticate()
.then(()=> console.log("Database connected"))
.catch(error => console.log(`Error: ${error}`));



const db = {}

db.Sequelize = Sequelize
db.sequelize = sequelize




db.userCategories = require('./userCategories.model')(sequelize, DataTypes)
db.customers = require('./customers.model')(sequelize, DataTypes)
db.logs = require('./logs.model')(sequelize, DataTypes)


db.sequelize.sync({ force: false  })
.then(() => {
    console.log('yes re-sync done!')
})


db.userCategories.hasMany(db.customers,{
  foreignKey: 'userCategoryId',
  as: 'customers'
});

db.customers.belongsTo(db.userCategories,{
foreignKey: 'userCategoryId',
as: 'userCategory'
});

db.customers.hasMany(db.logs,{
  foreignKey: 'customerId',
  as: 'logs'
});

db.logs.belongsTo(db.customers,{
foreignKey: 'customerId',
as: 'customer'
});

module.exports = db