const express = require('express');
const router = express.Router();
const moment = require('moment');
const Customer = require('../models/customer');
const Subscription = require('../models/subscription');
const Log = require('../models/logs');
const Score = require('../models/Resultado');
const Dashboard = require('../models/dashboard.model');


const userCategoriesService = require('../services/userCategories.service')
const customersService = require('../services/customers.service')
const logsService = require('../services/logs.service')






router.get('/log', (req, res)=>{
    res.render('log');
});


router.get('/log/:eid', async(req, res)=>{
    const { eid } = req.params;
    let result = await logsService.insertLogAndGetAssitance(eid)
    res.send(result);
});


router.get('/registrar', async (req, res)=>{
    try {
        let userCategories = await userCategoriesService.getActiveUserCategiries();
        res.render('reg', { userCategories });
    } catch (error) {
        console.log(error)
    }
    
});
router.post('/customer_reg',async(req,res)=>{
    await customersService.createCustomer(req.body)
  res.redirect('/home');
});
router.get('/search', (req, res)=>{
    res.render('customer_search');
});
router.post('/search/', async(req, res)=>{
    return res.json(await customersService.getUsersByKeyword(req.body.text))
});

router.get('/clientes', async (req, res)=>{
    const customers = await customersService.getCustumers();
    res.send(customers);
});


router.get('/list', async (req, res)=>{
    
    res.render('list'); 
});








router.get('/pay/:id', async (req, res)=>{
    const{id} = req.params;
    let customer = await customersService.getCustomerById(id)
     res.render('payment',{
        customer,        
     });  
});


router.post('/payPost/:id', async (req, res)=>{
    const{id} = req.params;

    const fecha = moment(req.body.inpt_date, 'YYYY-MM-DD');
    console.log(req.body.inpt_date)
    await customersService.pay(id, fecha);
     res.redirect('/search');  
});




router.get('/editar/:id', async (req, res)=>{
    const{id} = req.params;
    let customer = await customersService.getCustomerById(id);
    let categories = await userCategoriesService.getActiveUserCategiries();
     res.render('customer_edit',{
        customer,
        categories
     });  
});

router.post('/editar/:id', async (req, res)=>{
    const{id} = req.params;
    console.log(id);
    console.log(req.body);
    await customersService.updateCustomer(id, req.body);
     res.redirect('/search');  
});




router.get('/eliminarConfirm/:id', async (req, res)=>{
    const{id} = req.params;
    let customer = await customersService.getCustomerById(id);
     res.render('customer_delete',{
        customer
     });  
});

router.get('/eliminar/:id', async (req, res)=>{
    const{id} = req.params;
    await customersService.deleteCustoomer(id);
     res.redirect('/search');  
});





































router.get('/home', (req, res)=>{

    res.render('index.ejs');
});

router.get('/', (req, res)=>{    
    res.render('index.ejs');
});




router.get('/customer_list', async (req, res)=>{
    const customers = await Customer.find();
    res.render('customer_list',{
       customers
    }); 
});




/**/
router.get('/subscription/customers', async (req, res)=>{
    Customer.findOne({}, {}, { sort: { 'date' : -1 } }, function(err, date) {
        res.send( date );
      });

    
});

router.get('/subscription', (req, res)=>{
    res.render('subscription');
});

router.post('/subscription/info', async (req,res)=>{
    console.log(req.body);
    const sub = new Subscription(req.body);
    await sub.save();
    
    res.send(sub);
  });
































router.post('/log_reg',async(req,res)=>{
    console.log(req.body);
  const logs = new Log(req.body);
 await logs.save();
  res.send("HOLA")
});


router.get('/clientes_bitacora', async (req, res)=>{
    const logs = await Log.find().sort({date:-1});
    console.log(logs);
    res.send(logs); 
});

router.get('/customer_log', async (req, res)=>{
    
    res.render('customer_log'); 
});

module.exports = router;