const db = require('../db/index');
const moment = require('moment');
const customersService = require('../services/customers.service');
const { customers } = require('../db/index');


const insertLogAndGetAssitance = async(eid) =>
{
    let customerEntity = await db.customers.findOne({
        where: {
            evolutionId: eid
        }
    });
    if(customerEntity)
    {
        let formatedCustomer =  await customersService.getCustomerById(customerEntity.customerId);        
        if(formatedCustomer.status == "corriente")
        {
            await db.logs.create({
                customerId: customerEntity.customerId,
                date: moment(),
                createdAt: moment(),
                updatedAt: moment()
            })
        }
        let count = await db.logs.count({
            where: {
                customerId: customerEntity.customerId
            }
        });
        await determinarGradoYCinta(count, formatedCustomer.settingGrado, formatedCustomer.settingCinta)
     
        let { cinta, grado } =await determinarGradoYCinta(count, formatedCustomer.settingGrado, formatedCustomer.settingCinta);
        let formatedCinta = `Cinta ${cinta}`;
        let formatedGrado = `Grado ${grado}`;
        await updateGradoYCinta(formatedCinta, formatedGrado, formatedCustomer.id);
        formatedCustomer.cinta = formatedCinta ? formatedCinta : null;
        formatedCustomer.grado = formatedGrado ? formatedGrado : null;        
        return { result: true, customer: formatedCustomer, count }
    }
    else
    {
        return { result: false, customer:null, count:null }
    }
}

const updateGradoYCinta = async(cinta, grado, customerId) => {
    await db,customers.update({ 
        cinta,
        grado
    },{
        where:{
            customerId
        }
    });
}

const determinarGradoYCinta = async(asistenciasTotales, asistenciasPorGrado, asistenciasPorCinta) => {
    const gradoBase = 0;
    const cintaBase = 0;
    let grado = gradoBase;
    let cinta = cintaBase;
    if (asistenciasTotales >= asistenciasPorCinta) {
        cinta = Math.floor(asistenciasTotales / asistenciasPorCinta) + cintaBase;
    }    
    let mutip = Math.floor(asistenciasTotales/asistenciasPorCinta);    
    let paraRestar = mutip * asistenciasPorCinta;
    let asistenciasPorGradoResultado = asistenciasTotales - paraRestar;
    if (asistenciasTotales >= asistenciasPorGradoResultado) {
        grado = Math.floor(asistenciasPorGradoResultado / asistenciasPorGrado) + cintaBase;
    } 
    return { cinta, grado }
}


module.exports = {
    insertLogAndGetAssitance
}